=== debian/changelog ===
llvm-toolchain-14 (1:14.0.5-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 02 Jul 2022 13:55:50 -0700

llvm-toolchain-14 (1:14.0.5-1) unstable; urgency=medium

  * New upstream release
  * Only install grpc files libclang-X.Y-dev when grpc built
  * Remove cv-insn-support.patch (applied upstream)

  [ John Paul Adrian Glaubitz ]
  * Disable compiler-rt built-ins on x32

  [ Michael Biebl ]
  * Add support for systemd-binfmt (Closes: #1012368)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 11 Jun 2022 09:09:03 +0200

llvm-toolchain-14 (1:14.0.4-4) unstable; urgency=medium

  * autopkgtest: Restrict debian/qualify-clang.sh on
    amd64 arm64 i386

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 03 Jun 2022 10:52:10 +0200

llvm-toolchain-14 (1:14.0.4-3) unstable; urgency=medium

  * Fix GRPC installation path and files

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 31 May 2022 12:09:28 +0200

llvm-toolchain-14 (1:14.0.4-2) unstable; urgency=low

  * Add breaks/replaces for grpc binaries being placed in another package in Ubuntu
  * Fix GRPC installation for ports architectures
  * Add support for Ubuntu kinetic
  * rules: take some patches from Ubuntu to save extra space during build

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 29 May 2022 12:53:47 +0200

llvm-toolchain-14 (1:14.0.4-1) unstable; urgency=medium

  [ John Paul Adrian Glaubitz ]
  * Enable GRPC build dependency only on supported targets

  [ Sylvestre Ledru ]
  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 25 May 2022 08:49:20 +0200

llvm-toolchain-14 (1:14.0.3-2) unstable; urgency=medium

  * Fix an autopkgtest on arm (Closes:# 1010716)
    Thanks to Pino Toscano for the patch
  * Fix the search path for hip (Closes: #1010467)
  * Add the option -DLLVM_ENABLE_CURL=ON
    See https://github.com/llvm/llvm-project/issues/55289
    (LP: #1971743)

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 09 May 2022 20:40:39 +0200

llvm-toolchain-14 (1:14.0.3-1) unstable; urgency=medium

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 29 Apr 2022 09:23:16 +0200

llvm-toolchain-14 (1:14.0.2-1) unstable; urgency=medium

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 27 Apr 2022 08:36:00 +0200

llvm-toolchain-14 (1:14.0.1-1) unstable; urgency=medium

  * New upstream release
    Fixes the ABI issues

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 13 Apr 2022 09:33:24 +0200

llvm-toolchain-13 (1:13.0.1-6) unstable; urgency=medium

  [ John Paul Adrian Glaubitz ]
  * Disable compiler-rt built-ins on x32

  [ Gianfranco Costamagna ]
  * Enable grpc on riscv64

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 04 Jun 2022 15:30:38 +0200

llvm-toolchain-13 (1:13.0.1-5) unstable; urgency=medium

  [ John Paul Adrian Glaubitz ]
  * Enable GRPC build dependency only on supported targets
  * Exclude lib{Monitoring,RemoteIndex}*Proto.a on m68k and sparc64

  [ Gianfranco Costamagna ]
  * fix grpc architectures, avoiding to install them where not available
  * Break/Replaces the Ubuntu library that moved GRPC binaries into the wrong location
  * newline/tab fix in rules
  * fix GRPC installation in port architectures
  * Add patches from Upstream/Ubuntu to:
    - Backport upstream patches to allow building EFI images for Ubuntu Core
       for arm64 (LP: #1960300)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 26 May 2022 09:30:17 +0200

llvm-toolchain-13 (1:13.0.1-4) unstable; urgency=medium

  * Backport D115098 for Rust 1.59 (Closes: #1010150)

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 09 May 2022 20:47:26 +0200
